/*	Filename:FileInfo.h							*/
/************************************************/
/*												*/
/*			tt@CNX				*/
/*												*/
/*				For DSMP File.Inf				*/
/*												*/
/*					Ver.4.000  					*/
/*												*/
/*		Copyright 1999,2000 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#ifndef FileInfoH
#define FileInfoH

/*-----	ʒmbZ[W(WM_DSMPWParam)	-----*/

#ifndef	DSMP_FIND

#define	DSMP_FIND				(WM_USER)
#define	DSMP_HANDLE				(WM_USER+1)
#define	DSMP_CLOSE				(WM_USER+2)
#define	DSMP_SETTOOL			(WM_USER+3)

#endif

/*----------------------------------------------*/
/*												*/
/*----------------------------------------------*/

AnsiString __fastcall	GetDSMPPath(void);
AnsiString __fastcall	AbsPath(AnsiString Path,AnsiString BasePath);
AnsiString __fastcall	RelativePath(AnsiString Path,AnsiString BasePath);
AnsiString __fastcall	GetWindowsDir(void);
AnsiString __fastcall	GetSystemDir(void);
void __fastcall	DeleteFileInf(void);

/*----------------------------------------------*/
/*				TPlayInfoNX					*/
/*----------------------------------------------*/

class	TPlayInfo
{
private:
protected:
	int			FInfNo;					//Infԍ
	AnsiString	FSection;				//ZNV"Title"/"File"
	AnsiString	FName;					//L[
	AnsiString	FTitle;					//^Cg

	int __fastcall	FindInfFile(void);
	AnsiString __fastcall	GetPath(void);
	void __fastcall	SetName(AnsiString Name);
	virtual	void __fastcall	WriteValue(AnsiString Value);

public:
	__fastcall	TPlayInfo(void);
	__fastcall	TPlayInfo(AnsiString name);

	void __fastcall	Delete(void);
	virtual	AnsiString __fastcall	Read(AnsiString name);
	virtual	void __fastcall	Write(void);

	__property	AnsiString	Section={read=FSection,write=FSection};
	__property	AnsiString	Name={read=FName,write=FName};
	__property	int			InfNo={read=FInfNo,write=FInfNo};
	__property	AnsiString	Path={read=GetPath};
	__property	AnsiString	Title={read=FTitle,write=FTitle};
};

/*----------------------------------------------*/
/*				TPlayFileInfoNX				*/
/*----------------------------------------------*/

class	TPlayFileInfo:public TPlayInfo
{
	typedef	TPlayInfo	inherited;

private:
protected:
	AnsiString __fastcall	GetFileName(void);
	void __fastcall	SetFileName(AnsiString filename);
	AnsiString __fastcall	GetCommaText(void);
	void __fastcall			SetCommaText(AnsiString S);

public:
	AnsiString	Artist;					//A[eBXg
	int			Length;					//Đ
	AnsiString	Lyrics;					//̎t@C
	int			CD;						//CD
	int			Track;					//CDgbNԍ
	int			AdjustLyrics;			//̎\
	long		Time;					//^CX^v

	__fastcall	TPlayFileInfo(void);
	__fastcall	TPlayFileInfo(AnsiString name);
	virtual	AnsiString __fastcall	Read(AnsiString name);
	virtual	void __fastcall	Write(void);

	__property	AnsiString	FileName={read=GetFileName,write=SetFileName};
	__property	AnsiString	CommaText={read=GetCommaText,write=SetCommaText};
};

/*----------------------------------------------*/
/*				TCDListNX					*/
/*----------------------------------------------*/

class	TCDList
{
private:
	TList	*FList;

protected:
	int __fastcall	GetCount(void)
	{
		return(FList->Count);
	}
	TPlayInfo* __fastcall	GetItem(int Index);
	void __fastcall	SetItem(int Index,TPlayInfo *Info);
	TPlayInfo* __fastcall	GetInfo(int Length);
	AnsiString __fastcall	GetTitle(int Length);
	void __fastcall	SetTitle(int Length,AnsiString Title);

public:
	__fastcall	TCDList(void);
	__fastcall	~TCDList(void);

	void __fastcall	Clear(void);
	void __fastcall	Add(TPlayInfo* Info)
	{
		FList->Add(Info);
	}
	void __fastcall	Delete(int Index);
	int __fastcall	IndexOf(TPlayInfo *Info)
	{
		return(FList->IndexOf(Info));
	}
	int __fastcall	IndexOf(int Length);
	void __fastcall	Load(void);
	void __fastcall	Save(void);

	__property	AnsiString	Title[int Length]={read=GetTitle,write=SetTitle};
	__property	TPlayInfo	*Info[int Length]={read=GetInfo};
	__property	TPlayInfo	*Items[int Index]={read=GetItem,write=SetItem};
	__property	int			Count={read=GetCount};
	__property	TList*	List={read=FList};
};

/*----------------------------------------------*/
/*				TFileListNX					*/
/*----------------------------------------------*/

class	TFileList
{
private:
	TList	*FList;

protected:
	int __fastcall	GetCount(void)
	{
		return(FList->Count);
	}
	TPlayFileInfo* __fastcall	GetItem(int Index);
	void __fastcall	SetItem(int Index,TPlayFileInfo *Info);
	TPlayFileInfo* __fastcall	GetInfo(AnsiString Name);

public:
	__fastcall	TFileList(void);
	__fastcall	~TFileList(void);

	void __fastcall	Clear(void);
	void __fastcall	Add(TPlayFileInfo* Info)
	{
		FList->Add(Info);
	}
	void __fastcall	Delete(int Index);
	void __fastcall	Delete(AnsiString Name);
	int __fastcall	IndexOf(TPlayFileInfo *Info)
	{
		return(FList->IndexOf(Info));
	}
	int __fastcall	IndexOf(AnsiString Name);
	void __fastcall	Load(void);
	void __fastcall	Save(void);

	__property	TPlayFileInfo	*Info[AnsiString Name]={read=GetInfo};
	__property	TPlayFileInfo	*Items[int Index]={read=GetItem,write=SetItem};
	__property	int			Count={read=GetCount};
	__property	TList*	List={read=FList};
};

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

extern	AnsiString	DSMPPath;
extern	UINT		WM_DSMP;

#endif

/*****	End	*****/