/*	Filename:FindFile.cpp						*/
/************************************************/
/*												*/
/*			t@CNX					*/
/*												*/
/*					Ver.4.00  					*/
/*												*/
/*		Copyright 1997,2000 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "FindFile.h"

#pragma package(smart_init)

#ifndef	then
#define	then
#endif
#ifndef	AND
#define	AND	&&
#endif
#ifndef	OR
#define	OR	||
#endif

/*----------------------------------------------*/
/*				TFindFileNX					*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TFindFile::TFindFile(void)
{
	Init();
}

/*****	RXgN^	*****/

__fastcall	TFindFile::TFindFile(AnsiString Path)
{
	Init();
	Research(Path);
}

/*****		*****/

void __fastcall	TFindFile::Init(void)
{
	FHandle=0;
	FMask=0;
	FCurDir=false;
	FFindFirst=false;
}

/*****	fXgN^	*****/

__fastcall	TFindFile::~TFindFile()
{
	Close();
}

/*****	\`FbN	*****/

bool __fastcall	TFindFile::IsEnabled(void)
{
	if ((FHandle==0) OR (FHandle==INVALID_HANDLE_VALUE))
	then return(false);
	return(true);
}

/*****	FindFilenh̃N[Y	*****/

void __fastcall	TFindFile::Close(void)
{
	if (IsEnabled())
	then {
		 ::FindClose(FHandle);
		 FHandle=0;
	}
}

/*****	WIN32_FIND_DATAɃLXg	*****/

__fastcall	TFindFile::operator	WIN32_FIND_DATA()
{
	return(*((WIN32_FIND_DATA *)(&dwFileAttributes)));
}

/*****	DOSt@C̎擾	*****/

AnsiString __fastcall	TFindFile::GetShortFileName(void)
{
	return(AnsiString(cAlternateFileName));
}

/*****	t@C̎擾	*****/

AnsiString __fastcall	TFindFile::GetFileName(void)
{
	return(AnsiString(cFileName));
}

/*****	tpX擾	*****/

AnsiString	TFindFile::GetFullPath(AnsiString Path)
{
	char	bf[MAX_PATH];
	LPTSTR	FName;

	if (Path.IsEmpty())
	then	return(Path);

	if (::GetFullPathName(Path.c_str(),MAX_PATH,bf,&FName))
	then	Path=bf;
	else	Path="";

	return(Path);
}

/*****	t@CČ	*****/

bool __fastcall	TFindFile::Research(AnsiString Path)
{
	if (Enabled)
	then	Close();

	FFindPath=Path;
	FPath="";
	FFindFirst=false;
	if (!Path.IsEmpty())
	then {
		FHandle=::FindFirstFile(Path.c_str(),(WIN32_FIND_DATA *)&dwFileAttributes);
		FFindFirst=Enabled;
	}

	return(Enabled);
}

/*****	t@C	*****/

bool __fastcall	TFindFile::Find(DWORD mask)
{
	AnsiString	S;

	if (FFindFirst)
	then {
		FFindFirst=false;
	}
	else {
Loop:
		if ((Enabled==false) OR (!::FindNextFile(Handle,(WIN32_FIND_DATA *)&dwFileAttributes)))
		then {
			Close();
			FPath="";
			return(false);
		}
	}

	if (dwFileAttributes & mask)
	then goto Loop;								//}XNȂ玟

	FPath=ExtractFileName(cFileName);
	if (FCurDir==false)							//JgfBNgԂȂꍇ
	then {
		if ((FPath==".") OR (FPath==".."))
		then	goto Loop;
	}
	if (!(dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
	then {
		S=FPath;
		FPath=ExtractFileDir(FFindPath);
		FPath+="\\";
		FPath+=S;
	}
	if (cAlternateFileName[0]==0)
	then {
		char	bf[MAX_PATH];

		::GetShortPathName(FPath.c_str(),bf,MAX_PATH);
		S=ExtractFileName(bf);
		StrLCopy(cAlternateFileName,S.c_str(),14);
	}

	return(true);
}

/*****	t@C	*****/

bool __fastcall	TFindFile::Find(void)
{
	return(Find(FMask));
}

/*****	End	*****/
